﻿Imports System.Data.SqlClient

Public Class DBLookup

    Public Const CONNECTIONSTRING As String = "Server=localhost;Database=Demo;User Id=Kofax;Password=Kofax;"
    Public Const QUERY As String = "SELECT * FROM [Demo].[dbo].[suppliers-demo]"

    Private oTable As Table
    Private filteredTable As Table
    Public SelectedRow As Row


    Public Sub New()

        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialisation after the InitializeComponent() call.

        ' example: loading a CSV file
        'oTable = New Table("C:\ProgramData\Kofax\CaptureSV\Projects\db\suppliers-sample.csv", ",", """")
        ' example: querying a sql table
        oTable = New Table(CONNECTIONSTRING, QUERY)
        lblStatus.Text = String.Format("Ready, {0} entries in total", oTable.Rows.Count)

    End Sub

    Private Sub cmdSearch_Click(ByVal sender As System.Object, ByVal e As System.EventArgs)
        ' when the user hits enter, perform the search (but only if more than 3 characters are present!)
        If txtSearch.Text.Length > 3 Then
            Search(2)
        End If
    End Sub

    Private Sub txtSearch_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles txtSearch.KeyDown
        ' did the user press enter?
        If e.KeyCode = Keys.Return Then
            ' now we filter
            If txtSearch.Text.Length > 3 Then
                Search(2)
            End If
        End If
    End Sub

    Private Sub cmdGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdGo.Click
        AcceptResult()
    End Sub

    Private Sub lbxItems_DoubleClick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lbxItems.DoubleClick
        AcceptResult()
    End Sub

    Private Sub AcceptResult()
        ' when the user double clicks on an element, take that element
        SelectedRow = lbxItems.SelectedItem
        ' we could also hide the form right here.
        Me.Hide()
    End Sub


    Private Sub Search(ByVal columId As Integer)

        filteredTable = New Table()

        ' searches the column for the text entered
        For Each r As Row In oTable.Rows
            If UCase(r.Cells(columId).Content).Contains(UCase(txtSearch.Text)) Then
                ' add the newly found row
                filteredTable.Rows.Add(r)
            End If
        Next

        ' now bind elements to listbox
        lbxItems.DataSource = filteredTable.Rows
        lbxItems.DisplayMember = "Row"

        ' show results
        lblStatus.Text = String.Format("{0} results found", filteredTable.Rows.Count)

    End Sub

    Public Custom Event ListboxEntrySelected As EventHandler
        AddHandler(ByVal value As EventHandler)
            Me.Events.AddHandler("ListboxEntrySelectedEvent", value)
        End AddHandler

        RemoveHandler(ByVal value As EventHandler)
            Me.Events.RemoveHandler("ListboxEntrySelectedEvent", value)
        End RemoveHandler

        RaiseEvent(ByVal sender As Object, ByVal e As System.EventArgs)
            CType(Me.Events("ListboxEntrySelectedEvent"), EventHandler).Invoke(sender, e)
        End RaiseEvent
    End Event


    Private Sub lbxItems_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles lbxItems.KeyDown

        If e.KeyCode = Keys.Return Then
            Dim evhandler As EventHandler = CType(Me.Events("ListboxEntrySelectedEvent"), EventHandler)
            If evhandler IsNot Nothing Then
                AcceptResult()
                evhandler.Invoke(Me, e)
            End If
        End If
    End Sub
End Class
