﻿Imports System.IO
Imports System.Data.SqlClient

Public Class Table

    Public Rows As List(Of Row)

    Public Sub New(ByVal ConnectionString As String, ByVal Query As String)

        Dim conn As SqlConnection
        Dim i As Integer
        Dim strSQL As String = Query
        Dim dt As New System.Data.DataTable()

        Rows = New List(Of Row)

        Using cnn As New SqlConnection(ConnectionString)
            cnn.Open()
            Using dad As New SqlDataAdapter(strSQL, cnn)
                dad.Fill(dt)
            End Using
            cnn.Close()
        End Using

        For Each row As DataRow In dt.Rows
            ' add a row, and then adds a cell for each corresponding cell in the table
            Me.Rows.Add(New Row())
            For i = 0 To row.ItemArray.Count - 1
                Me.Rows.Last().Cells.Add(New Cell(row.Item(i)))
            Next
        Next row
    End Sub

    Public Sub New(ByVal csv As String, ByVal sepChar As Char, ByVal escapeChar As Char)

        Dim buffer As String
        Dim cells() As String
        Dim i As Integer

        Rows = New List(Of Row)

        Using reader As StreamReader = File.OpenText(csv)

            While Not reader.EndOfStream
                buffer = reader.ReadLine()
                cells = Split(buffer, sepChar)

                ' make a new row
                Rows.Add(New Row())

                For i = 0 To cells.Length - 1
                    ' replace escape char
                    Rows.Last().Cells.Add(New Cell(cells(i).Replace(escapeChar, "")))
                Next


            End While

        End Using

    End Sub

    Public Sub New()
        Rows = New List(Of Row)
    End Sub

End Class
